"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeMockCurryFn = void 0;
var utils_1 = require("./utils");
var makeMockCurryFn = function (options) {
    var nCurriedFns = options.nCurriedFns, tailFnReturnValue = options.tailFnReturnValue;
    utils_1.validateMockCurryFnOptions(options);
    var mockFns = utils_1.makeMockFns(nCurriedFns);
    var tailMockFnIndex = nCurriedFns - 1;
    var headMockFn = mockFns[0];
    var tailMockFn = mockFns[tailMockFnIndex];
    utils_1.chainMockCurryFnsReturns(mockFns);
    utils_1.setTailMockFnReturnValue(mockFns, tailFnReturnValue);
    var expectMockFnsCalledWith = utils_1.makeExpectCurriedMockFns({
        mockFns: mockFns,
        index: 0,
    });
    return {
        expectMockFnsCalledWith: expectMockFnsCalledWith,
        headMockFn: headMockFn,
        tailMockFn: tailMockFn,
        mockFns: mockFns,
        options: options,
    };
};
exports.makeMockCurryFn = makeMockCurryFn;
